.\"	$NetBSD: jme.4,v 1.5 2008/10/17 20:02:39 bouyer Exp $
.\"
.\" Copyright (c) 2008 Manuel Bouyer
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd October 17, 2008
.Dt JME 4
.Os
.Sh NAME
.Nm jme
.Nd JMicron Technologies JMC250 Gigabit Ethernet and JMC260 Fast Ethernet controller driver
.Sh SYNOPSIS
.Cd "jme* at pci? dev ? function ?"
.Pp
Configuration of PHYs is necessary.
See
.Xr mii 4 .
.Sh DESCRIPTION
The
.Nm jme
device driver supports network adapters based on the JMicron
Technologies JMC250 Gigabit Ethernet and JMC260 Fast Ethernet chips.
The following features are supported:
.Bd -literal -offset indent
IPv4 transmit/receive IP/TCP/UDP checksum offload
IPv6 transmit TCP/UDP checksum offload
IPv4 and IPv6 TCP segmentation offload
VLAN tag insertion/removal
Interrupt coalescing
10/100/1000Mbps operation in full-duplex mode
10/100Mbps operation in half-duplex mode
Jumbo frames (up to 9022 bytes)
.Ed
.Pp
Due to hardware limitation checksums and TCP segmentation offload can't
be enabled if the configured MTU is larger than 4000 bytes.
.Pp
Interrupt coalescing can be controlled on a per-adapter basis through
the following sysctls:
.Bl -tag -width ".Cm hw.jme.jmeXxX.int_rxtos"
.It Cm hw.jme.jme\*[Lt]x\*[Gt].int_rxtos
jme receive interrupt moderation timer, in microseconds (defaults to 100)
.It Cm hw.jme.jme\*[Lt]x\*[Gt].int_rxct
jme receive interrupt moderation packet counter (defaults to 128)
.It Cm hw.jme.jme\*[Lt]x\*[Gt].int_txto
jme transmit interrupt moderation timer, in microseconds (defaults to 100)
.It Cm hw.jme.jme\*[Lt]x\*[Gt].int_txct
jme transmit interrupt moderation packet counter (defaults to 128)
.El
.Sh SEE ALSO
.Xr ifmedia 4 ,
.Xr mii 4 ,
.Xr netintro 4 ,
.Xr pci 4 ,
.Xr ifconfig 8
.Sh HISTORY
The
.Nm
device driver first appeared in
.Nx 5.0 .
.Sh BUGS
Hardware bugs prevent support of IPv6 receive TCP/UDP checksum offload
in the JMC250 rev A2, and is disabled in the driver.
This should be revisited when a newer hardware revision is available.
